import { useRef, useState, useMemo } from "react";
import { Table, Button, Space, Popconfirm, Flex, message, Tooltip, Switch, Tag } from "antd";
import { EditOutlined, DeleteOutlined, PlusOutlined } from "@ant-design/icons";
import { useQuery, useMutation } from "@tanstack/react-query";
import { GetVqdTimeTemplate, DeleteVqdTimeTemplate, UpdateVqdTimeTemplate } from "../api/vqdtimetemplate";
import type { VqdTimeTemplateItem, CreateVqdTimeTemplateReq } from "../types/vqdtimetemplate";
import type { ColumnsType } from "antd/es/table";
import AddVqdTimeTemplate, { AddVqdTimeTemplateRef } from "./AddVqdTimeTemplate";
import { useGlobal } from "../Context";
import { FormatFileSizeToString } from "../utils/rate";
import { formatSecondsToHMS } from "../utils/time";
import Filter from "./Filter";
export default function VqdTimeTemplatePage() {
  const { ErrorHandle } = useGlobal();
  const dialogRef = useRef<AddVqdTimeTemplateRef>(null);
  const [pagination, setPagination] = useState({
    page: 1,
    size: 10,
    name: ""
  });

  // 获取任务列表
  const {
    data: storageResponse,
    isLoading,
    refetch,
  } = useQuery({
    queryKey: ["storage", pagination],
    queryFn: () =>
      GetVqdTimeTemplate({ ...pagination })
        .then((res) => res.data)
        .catch((err) => {
          ErrorHandle(err);
          throw err;
        }),
    // refetchInterval: 4000,
    retry: 2,
  });

  // 删除任务
  const [delLoadings, setDelLoadings] = useState<number[]>([]);
  const { mutate: deleteMutation } = useMutation({
    mutationFn: DeleteVqdTimeTemplate,
    onMutate: (id: number) => {
      setDelLoadings((prev) => [...prev, id]);
    },
    onSuccess: (_, ctx) => {
      setDelLoadings((prev) => prev.filter((item) => item !== ctx));
      message.success("删除成功");
      refetch();
    },
    onError: (error: Error, ctx) => {
      setDelLoadings((prev) => prev.filter((item) => item !== ctx));
      ErrorHandle(error);
    },
  });

  // 打开新增模态框
  const handleAdd = () => {
    dialogRef.current?.open();
  };

  // 打开编辑模态框
  const handleEdit = (disk: VqdTimeTemplateItem) => {
    dialogRef.current?.open(disk);
  };
  const saveTemplate = (disk: VqdTimeTemplateItem, t: boolean) => {
    const payload = disk as CreateVqdTimeTemplateReq;
    payload.enable = t
    updateMutate({ id: String(disk.id), ...payload })
  };

  // 处理分页变化
  const handleTableChange = (page: number, pageSize?: number) => {
    setPagination((prev) => ({
      ...prev,
      page: page,
      size: pageSize || prev.size,
    }));
  };

  // 客户端分页数据
  const dataSource = useMemo(() => {
    const items = storageResponse?.items || [];
    const start = (pagination.page - 1) * pagination.size;
    const end = start + pagination.size;
    return items.slice(start, end);
  }, [storageResponse, pagination]);
  const [selectedRowKeys, setSelectedRowKeys] = useState<React.Key[]>([]);
  const rowSelection = {
    selectedRowKeys,
    onChange: (
      newSelectedRowKeys: React.Key[],
      selectedRows: VqdTimeTemplateItem[]
    ) => {
      setSelectedRowKeys([...newSelectedRowKeys]);
    },
  };
  const { mutate: updateMutate } = useMutation({
    mutationFn: UpdateVqdTimeTemplate,
    onSuccess: () => {
      message.success("更新成功");
      setTimeout(() => {
        refetch()
      }, 500);
    },
    onError: ErrorHandle,
  });
  // 表格列定义
  const columns: ColumnsType<VqdTimeTemplateItem> = [
    {
      title: "名称",
      dataIndex: "name",
      align: "center",
    },
    {
      title: "启用",
      dataIndex: "enable",
      align: "center",
      render: (text, record) => (
        <Space>
          <Switch value={text} defaultChecked onChange={(t) => {
            saveTemplate(record, t)
          }} />
        </Space>
      ),
    },
    {
      title: "描述",
      dataIndex: "des",
      align: "center",
    },
    // {
    //   title: "日期",
    //   dataIndex: "created_at",
    //   align: "center",
    //   render: (text: string, record) => (
    //     <>
    //       <div>创建:{(text ? new Date(text).toLocaleString() : "-")}</div>
    //       更新:{(record?.updated_at ? new Date(record?.updated_at).toLocaleString() : "-")}
    //     </>
    //   ),
    // },
    {
      title: "操作",
      align: "center",
      width: 120,
      fixed: "right",
      render: (_, record) => (
        <Space>

          <Tooltip placement="top" title="编辑" color="#fff">
            <Button icon={<EditOutlined />} onClick={() => handleEdit(record)} />
          </Tooltip>
          {!record.is_default && <Popconfirm
            title="确定要删除这个模板吗？"
            onConfirm={() => {
              if (record.id) {
                deleteMutation(record.id);
              }
            }}
            okText="确定"
            cancelText="取消"
          >
            <Button
              loading={delLoadings.includes(record.id)}
              danger
              icon={<DeleteOutlined />}
            />
          </Popconfirm>}

        </Space>
      ),
    },
  ];

  return (
    <div>
      <Flex justify="space-between" align="center" className="mb-4">
        <Space>
          <Button type="primary" icon={<PlusOutlined />} onClick={handleAdd}>
            新增计划
          </Button>
          {/* <Popconfirm
            title="确定要批量删除文件吗？"
            onConfirm={() => {
             
            }}
            okText="确定"
            cancelText="取消"
          >
            <Button color="danger" variant="solid">
              批量删除
            </Button>
          </Popconfirm> */}

        </Space>

        <Filter
          searchLoading={isLoading}
          onSearchChange={(value: string) => {
            setPagination({ ...pagination, name: value });
          }}
        />
      </Flex>
      {/* 表格 */}
      <Table
        columns={columns}
        // rowSelection={rowSelection}
        dataSource={storageResponse?.items}
        rowKey="id"
        loading={isLoading}
        scroll={{ x: "max-content" }}
        pagination={{
          current: pagination.page,
          pageSize: pagination.size,
          total: storageResponse?.total || 0,
          showSizeChanger: true,
          showQuickJumper: true,
          showTotal: (total) => `共 ${total} 条`,
          onChange: handleTableChange,
          onShowSizeChange: handleTableChange,
        }}
      />

      {/* 编辑模态框 */}
      <AddVqdTimeTemplate
        ref={dialogRef}
        title="添加/编辑模板"
        onSuccess={() => refetch()}
      />
    </div>
  );
}
